'use strict';'require view';'require dom';'require ui';'require form';'require rpc';'require fs';'require uci';document.querySelector('head').appendChild(E('link',{'rel':'stylesheet','type':'text/css','href':L.resource('view/change-password/css/custom.css')}));var formData={password:{pw1:null,pw2:null}};var callGetUser=rpc.declare({object:'session',method:'get',reject:true,expect:{values:{}}});function checkPassword(section_id,value){var strongRegex=new RegExp("^(?=.{8,})(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*\\W).*$","g"),mediumRegex=new RegExp("^(?=.{7,})(((?=.*[A-Z])(?=.*[a-z]))|((?=.*[A-Z])(?=.*[0-9]))|((?=.*[a-z])(?=.*[0-9]))).*$","g"),enoughRegex=new RegExp("(?=.{6,}).*","g"),error='';if(value.length){if(false==enoughRegex.test(value))
error='%s: %s'.format(_('Password strength'),_('More Characters'));else if(strongRegex.test(value))
error='';else if(mediumRegex.test(value))
error='%s: %s'.format(_('Password strength'),_('Medium'));else
error='%s: %s'.format(_('Password strength'),_('Weak'));}
if(error!=''){return error;}
return true;}
var username;function loadUsers(){return new Promise(function(resolve){let logins=uci.sections('rpcd','login');resolve(logins);return;});}
return view.extend({load:function(){return callGetUser(L.env.sessionid).then(function(res){username=res.username;});},render:function(){var m,s,o;m=new form.Map('rpcd',_('Change Password'),_('Changes your password for accessing the device'));m.readonly=!L.hasViewPermission();s=m.section(form.TypedSection,'login');s.load=function(){return Promise.all([loadUsers()]).then(L.bind(function(data){this.users=data[0];},this));};s.anonymous=true;s.addremove=true;s.cfgsections=function(){return this.users.filter(function(user){return user.username==username});};s.renderRowActions=function(section_id){var tdEl=this.super('renderRowActions',[])
return tdEl;};s.handleAdd=function(ev){return false;};s.handleRemove=function(section_id,ev){return false;};o=s.option(form.DummyValue,'username',_('Login name'));o.rmempty=false;o.datatype='string';o.cfgvalue=function(section){var value=section.username;return value;}
o=s.option(form.Value,'_pw1','Password');o.datatype='string';o.validate=checkPassword;o.password=true;o=s.option(form.Value,'_pw2','Password Confirmation');o.datatype='string';o.password=true;o.renderWidget=function(){var node=form.Value.prototype.renderWidget.apply(this,arguments);node.querySelector('input').addEventListener('keydown',function(ev){if(ev.keyCode==13&&!ev.currentTarget.classList.contains('cbi-input-invalid'))
document.querySelector('.cbi-button-save').click();});return node;};o=s.option(form.DummyValue,'_cfg_name',_(''));o.modalonly=false;o.hidden=true;o.cfgvalue=function(section){return section['.name'];};return m.render();},handleSave:function(){var pw1=document.getElementById('widget.cbid.rpcd.[object Object]._pw1').value;var pw2=document.getElementById('widget.cbid.rpcd.[object Object]._pw2').value;var section_name=document.getElementById('cbid.rpcd.[object Object]._cfg_name').value;if(pw1==null||pw1.length==0)
return;if(pw1!=pw2){ui.addNotification(null,E('p',_('Passwords do not match, password not changed.')),'danger');return;}
if(pw1.length<6){ui.addNotification(null,E('p',_('Password is not long enough.')),'danger');return;}
startSpinner();return fs.exec('/usr/sbin/mkpasswd',[pw1]).then(function(res){uci.set('rpcd',section_name,'password',res.stdout.trim());uci.save().then(function(){uci.apply().then(function(){setTimeout(function(){location.reload();},1000);}).catch(()=>{stopSpinner();});});});},handleSaveApply:null,handleReset:null});